import time, threading, datetime
from board import BoardControl
from Tkinter import *

class timer(threading.Thread):
    def __init__(self, master, competiters, threshold):
        self.is_stop=False
        self.competiters=competiters
        self.cout=0
        threading.Thread.__init__(self)
        self.board = BoardControl()
        self.board.summation = 8
        self.threshold = threshold
        self.master = master
        self.detected = False

    def get_time(self, d):
        return "%02d:%02d:%02d"%(d.seconds/60,d.seconds,int(str(d.microseconds/1000)[:2]))

    def run(self):
        self.is_stop=False
        t1=datetime.datetime.now()

        while 1:
            if self.is_stop or (self.cout == self.competiters):
                break

            t2=datetime.datetime.now()
            d = t2-t1
            self.master.clock.configure(text=self.get_time(d))

            light = self.board.get_light()
            print light, self.threshold
            if (light < self.threshold):
                if not self.detected:
                    self.cout+=1
                    self.master.results.insert(END, str(self.cout) + " - " + self.get_time(d))
                    self.detected = True
            else:
                self.detected = False

class Runner():
    threshold = 1000
    
    def __init__(self, master, competiters):
        self.competiters=competiters
        self.times = None
        self.master = master

    def start(self):
        self.reset()
        self.times = timer(self.master, self.competiters, Runner.threshold)
        self.times.start()

    def reset(self):
        if ( self.times is not None ):
            self.times.is_stop = True
        self.times = None

    def calibrate(self, normal,laser):
        Runner.threshold = (normal + (laser * 3)) / 4
    
